%def_without mdkmenu
%def_without legacymenu
BuildRequires: /proc
BuildRequires: jpackage-1.4-compat
%define version 3.2
%define name jext
# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support 0

%define appdir  %{_datadir}/%{name}

Name:           jext
Version:        3.2
Release:        alt2_0.pre4.3jpp1.7
Epoch:          0
Summary:        Free source code editor written in Java
License:        GPL
URL:            http://www.jext.org/
Group:          Editors
Source0:        http://osdn.dl.sourceforge.net/jext/jext-sources-3.2pre4.tar.gz
Source1:        %{name}-script
Source2:        %{name}-icon-16.png
Source3:        %{name}-icon-32.png
Source4:        %{name}-icon-48.png
Source5:        %{name}.desktop
Requires: aelfred
Requires: gnu-regexp
Requires: jpackage-utils >= 0:1.6
Requires: jython
BuildRequires: ant
BuildRequires: aelfred
BuildRequires: gnu-regexp
BuildRequires: jpackage-utils >= 0:1.6
BuildRequires: jython
%if ! %{gcj_support}
BuildArch:      noarch
%endif
%if %{gcj_support}
BuildRequires: gnu-crypto
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif

%description
Jext was created to support Java programming language. But nowadays it
can edit many other types of source codes. Among them you'll find C,
C++, C#, ASP, PHP, Python, Perl, Ruby, TeX, XHTML, XSLT, Eiffel, JSP...
Besides it provides advanced features to ease you work. Manage your
projects with the bookmarks tool, categorize your opened files through
workspaces, directly open zipped files, get a file straight from the
Internet, mail your source code, executes system commands within the
internal console, type faster thanks to HyperTyper and to the
customizable code snippets library, add new features with plugins,
discover the advanced editing capabilities, use the internal Python
interpreter... Jext meets all your needs! Developers will also
appreciate the open architecture of Jext. Based on GPLed libraries,
internal Python interpreter and many XML files, improving Jext is an
easy job. You can even write your own plugins (in Python or Java).

%if_with mdkmenu
%package        mdkmenu
Summary:        Mandrake menu entry for %{name}
Group:          Networking/Instant messaging
Requires: %{name} = %{epoch}:%{version}-%{release}
%endif #mdkmenu

%if_with mdkmenu
%description    mdkmenu
%{summary}.
%endif #mdkmenu

%if_with legacymenu
%package        legacymenu
Summary:        Legacy menu entry for %{name}
Group:          Networking/Instant messaging
Requires: %{name} = %{epoch}:%{version}-%{release}
Conflicts: redhat-menus
%endif #legacymenu

%if_with legacymenu
%description    legacymenu
%{summary}.
%endif #legacymenu

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.

%prep
%setup -q -n jextSrc-3.2pre4
# remove internal aelfred sources
rm -rf src/lib/com
# remove internal gnu.regexp sources
rm -rf src/lib/gnu
# remove old jedit syntax sources
# FIXME: we don't package a version of jedit this old
#rm -rf src/lib/org/gjt

%build
pushd src
export CLASSPATH=$(build-classpath aelfred gnu.regexp jython)
perl -p -i -e 's|compress="no"|compress="yes"|g' build.xml
perl -p -i -e 's|^Class-Path:||g' %{name}.manifest
ant jar javadocs
popd

%install

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 lib/%{name}.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 lib/dawn.jar \
$RPM_BUILD_ROOT%{_javadir}/%{name}-dawn-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do \
ln -sf ${jar} ${jar/-%{version}/}; done)

# data
install -p -d -m 755 $RPM_BUILD_ROOT%{appdir}

# scripts
install -D -p -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# javadoc
install -p -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr docs/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
(cd $RPM_BUILD_ROOT%{_javadocdir} && ln -sf %{name}-%{version} %{name})

# mdk menu entry
install -p -d -m 755 $RPM_BUILD_ROOT%{_menudir}
cat >$RPM_BUILD_ROOT%{_menudir}/%{name} <<EOF
?package(%{name}):\\
command="%{_bindir}/%{name}"\\
needs="X11"\\
icon="%{name}.png"\\
section="Applications/Editors"\\
title="%{name}" \\
longtitle="Free source code editor written in Java"
EOF

# mdk icons
install -D -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_miconsdir}/%{name}.png 
install -D -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_iconsdir}/%{name}.png 
install -D -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_liconsdir}/%{name}.png

# freedesktop.org menu entry
install -D -p -m 644 %{SOURCE5} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}.desktop

# icons for freedesktop.org and legacy menu entries
install -D -p -m 644 %{SOURCE2} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
install -D -p -m 644 %{SOURCE3} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png

# legacy menu entry
install -D -p -m 644 %{SOURCE4} \
  $RPM_BUILD_ROOT%{_sysconfdir}/X11/applnk/Development/%{name}.desktop

%if %{gcj_support}
export CLASSPATH=$(build-classpath gnu-crypto)
%{_bindir}/aot-compile-rpm
%endif

mkdir -p $RPM_BUILD_ROOT`dirname /etc/jext.conf`
touch $RPM_BUILD_ROOT/etc/jext.conf
# fix to report
%__subst 's,Categories=Application;Development;X-JPackage;,Categories=X-JPackage;Java;Development;IDE;,' $RPM_BUILD_ROOT%_desktopdir/jpackage-jext.desktop

# hack around push_body in %%if_ed posts!!!
%post
%update_menus
%postun
%clean_menus


%if_with mdkmenu
%post mdkmenu
%update_menus
%endif #mdkmenu
 
%if_with mdkmenu
%postun mdkmenu
%clean_menus
%endif #mdkmenu

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%doc LICENSE SOURCES
%{_javadir}
%attr(0755,root,root) %{_bindir}/*
%dir %{appdir}
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/*/*/apps/*
%{_datadir}/pixmaps/%{name}.png
%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%{_libdir}/gcj/%{name}/%{name}-dawn-%{version}.jar.*
%endif
%config(noreplace,missingok) /etc/jext.conf

%if_with mdkmenu
%files mdkmenu
%{_menudir}/%{name}
%{_iconsdir}/%{name}.png
%{_miconsdir}/%{name}.png
%{_liconsdir}/%{name}.png
%endif #mdkmenu

%if_with legacymenu
%files legacymenu
%{_sysconfdir}/X11/applnk/Development/*
%endif #legacymenu

%files javadoc
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}

%changelog
* Fri Nov 16 2007 Igor Vlasenko <viy@altlinux.ru> 0:3.2-alt2_0.pre4.3jpp1.7
- converted from JPackage by jppimport script

* Thu Nov 15 2007 Igor Vlasenko <viy@altlinux.ru> 0:3.2-alt1_0.pre4.3jpp1.7
- converted from JPackage by jppimport script

